

GetScreenPos:	;BH,BL = X,Y	Returns ES:DI=Destination
	push bx
	push ax
		xor ax,ax
		mov al,bh
		mov di,ax
		xor ax,ax
		mov al,bl
		mov bx,320
		mul bx
		add di,ax
		mov ax,0A000h 
		mov es,ax
	pop ax
	pop bx
	ret
	

GetScreenNextLine:
	push ax
		mov ax,di
		add ax,320
		mov di,ax
	pop ax
	ret

ScreenInit:
	mov ah, 0           ; int 10,0
    mov al, 13h           ; mode 4 (cga 320x200 4 color)
    int 10h             ; bios int
	ret
 ; VGA 320x200, 256-color (video mode 13H)
 ; Segment: a000
  ; Layout: Linear, packed-pixel.  This mode uses one byte (8 bits) per
          ; pixel.  The colors displayed depend on the palette settings.

          ; Each scan line is 320 bytes long and there are 200 scan lines
          ; (regen size=64,000 bytes).  Each byte contains 1 pixel (64,000
          ; total pixels).



PrintChar:
	push si
	push di
	push dx
	push cx
	push bx
	push ax
		push ds
			push ax
				
				
				
			;	call domonitor
				
				mov ax,0
				mov al,[ds:CursorY]
				mov bx,320*8
				mul bx
				mov di,ax
				
				mov ax,0
				mov al,[ds:CursorX]
				mov cl,3
				rcl ax,cl
				add di,ax
				
				
				mov si,offset BitmapFont
				
				mov ax, seg BitmapFont
				mov ds, ax
			
			pop ax
			sub al,32
			mov ah,0
			rcl ax,1
			rcl ax,1
			rcl ax,1
			add si,ax
			
			
			mov cx,8
			push es
				mov ax,0A000h 
				mov es,ax
FontAgainVGA:	
				Call DoPairVGA
				add di,320
				;add di,2000h
				dec cx
				jnz FontAgainVGA
			pop es
		pop ds
		inc [ds:CursorX]
		cmp [ds:CursorX],40
		jne PrintCharNoNewLine
		call NewLine
PrintCharNoNewLine:
	pop ax
	pop bx
	pop cx
	pop dx
	pop di
	pop si
	ret

	
DoPairVGA:
	mov al,[ds:si]
	push di
		call PrintCharDoPart
		call PrintCharDoPart
		call PrintCharDoPart
		call PrintCharDoPart
		call PrintCharDoPart
		call PrintCharDoPart
		call PrintCharDoPart
		call PrintCharDoPart
	pop di
	
	inc si
	ret	
PrintCharDoPart:
	mov ah,0
	rcl al,1
	rcl ah,1	
	mov dh,ah
	rcl ah,1
	or ah,dh
	rcl ah,1
	or ah,dh
	rcl ah,1
	or ah,dh
	;and ah,[FontColor]
	mov es:[di],ah
	inc di
	ret


Locate:
		mov [ds:CursorX],bh
		mov [ds:CursorY],bl
	ret
NewLine:
		mov [ds:CursorX],0
		inc [ds:CursorY]
	ret
	
PrintSpace:
	push ax
		mov al,' '
		call PrintChar
	pop ax
	ret

SetPalette:		;Works on EGA/VGA
	
	
	
	push dx
	push cx
	push bx
	push ax 
	
		mov bx,ax	;Color
		mov cl,2
		
		mov al,dh
		and al,00001111b
		shl al,cl
		mov ch,al	;G (6 bit 0-63)


		mov al,dl
		and al,11110000b
		shr al,cl
		mov dh,al	;r		
		
		mov al,dl
		and al,00001111b
		shl al,cl
		mov cl,al	;b
	
		mov bh,0 
		mov ax,1007h 	;Select Color
		int 10h 
		
		mov bl,bh 
		mov bh,0 
		mov ax,1010h 
		int 10h 
	pop ax
	pop bx
	pop cx
	pop dx
	ret